$.Msg($.GetContextPanel());
function repeat(pattern, count) { 
    if (count < 1) return '';
    var result = '';
    while (count > 1) {
        if (count & 1) result += pattern;
        count >>= 1, pattern += pattern;
    }
    return result + pattern;
}
function FindChildByPath(root, path, print) {
    var elem = root;
    if (print) {
        $.Msg("=========");
    }
    while (path.length > 0) {
        var index = path[0];
        elem = elem.FindChildTraverse(index);
        if (print) {
            $.Msg(elem.id + " " + index);
        }
        path = path.splice(1,path.length-1);
    }
    if (print) {
        $.Msg("=========");
    }
    return elem;
}
function FindChildFromRoot(path, print) {
    var elem = $.GetContextPanel().GetParent();
    return FindChildByPath(elem,path, print);
}
function innerDump(indent, object) {
    for (var v in object) {
        if(typeof object[v] == "object") {
            $.Msg(repeat("\t", indent) + "\""+v+"\" : {");
            indent++;
            innerDump(indent, object[v]);
            indent--;
            $.Msg(repeat("\t", indent) + "},");
        } else if(typeof object[v] == "function") {
            //Suckers!
        } else {
            $.Msg(repeat("\t", indent) + "\""+v+"\" : \""+object[v]+"\",");
        }
    }
}

$.Msg("Welcome to Ingame, population ME!");
$.Msg("Success");//
Game.moonduck_ingame = function() {
    $.Msg("moonduck_ingame pressed");
    /*$.GetContextPanel().RemoveAndDeleteChildren();
    running = !running;
    if (running) {
        dirty = true;
         $.Schedule(0.05, updateLoop);   
    }*/
    $("#test").RemoveClass("Hidden");
}

GameEvents.Subscribe("dota_player_pick_hero", function(keys) {
    $.Msg("===== DOTA_PLAYER_PICK_HERO =====")
    $.Msg("Player: " + keys.player);
    $.Msg("Index:  " + keys.heroindex);
    $.Msg("Hero:   " + keys.hero);
    $.Msg("=================================");
} );
////
var couriercache = [];
GameEvents.Subscribe("dota_inventory_changed", function() {
    for (var entity of Entities.GetAllEntitiesByClassname("npc_dota_courier")) {
        if ((entity in couriercache) == false) {
            $.Msg("New Cache for " + entity);
            couriercache[entity] = {}
            var i = -1;
            while (i++ < 8) {
                couriercache[entity] = -1;
            }
        }
        var cache = {}
        cacheSuccess = true;
        var i = -1;
        while (i++ < 8) {
            var item = Entities.GetItemInSlot(entity, i);
            cache[i] = item;
            if (couriercache[entity][i] != item) {
                cacheSuccess = false;
            }
        }
        if (!cacheSuccess) {
            $.Msg(Entities.GetTeamNumber(entity) == 2 ? "Radiant" : "Dire");
            $.Msg("0: " + Abilities.GetAbilityName(cache[0]) + "\t| 1: " + Abilities.GetAbilityName(cache[1]) + "\t| 2: " + Abilities.GetAbilityName(cache[2]));
            $.Msg("3: " + Abilities.GetAbilityName(cache[3]) + "\t| 4: " + Abilities.GetAbilityName(cache[4]) + "\t| 5: " + Abilities.GetAbilityName(cache[5]));
            $.Msg("6: " + Abilities.GetAbilityName(cache[6]) + "\t| 7: " + Abilities.GetAbilityName(cache[7]) + "\t| 8: " + Abilities.GetAbilityName(cache[8]));
            //TODO: Network to bukka or do native shit
        }
        couriercache[entity] = cache;
    }
});
GameEvents.Subscribe("dota_player_update_hero_selection", function() {
    var i = -1;
    while (i++ < 64) {
        if (Players.IsValidPlayerID(i) && !Players.IsSpectator(i)) {
            $.Msg(i + "| " + Players.GetPlayerName(i));
            $.Msg(Players.GetPlayerSelectedHero(i));
            //TODO: Network to bukka or do native shit
            //TODO: Check up if this still works when panoramization kicks in
        }
    }
});